#include "SoPC.h"

static void buttons_isr (void* context, alt_u32 id) {
volatile int* buttons_status = (volatile int*) context;

*buttons_status = IORD_ALTERA_AVALON_PIO_EDGE_CAP (BUTTONS_BASE);
IOWR_ALTERA_AVALON_PIO_EDGE_CAP (BUTTONS_BASE, 0x0);
IOWR_ALTERA_AVALON_PIO_IRQ_MASK (BUTTONS_BASE, 0xF);

}

int main (void) {

int i, errors = 0;
alt_u32 in_buf[TEST_DATA_SIZE], out_buf[TEST_DATA_SIZE];
alt_flash_fd* flash_handle;

volatile int buttons_status = 0;
int button_pressed, switches;

printf ("Testing Flash Memory\n");

flash_handle = alt_flash_open_dev (FLASH_NAME);

for (i = 0; i < TEST_DATA_SIZE; i++) {
in_buf[i] = i + 1000000;}

alt_write_flash (flash_handle, 0, in_buf, TEST_DATA_SIZE*4);
alt_read_flash (flash_handle, 0, out_buf, TEST_DATA_SIZE*4);

for (i = 0; i < TEST_DATA_SIZE; i++) {
if (out_buf[i] != (i + 1000000))
errors++;}

alt_flash_close_dev (flash_handle);

printf ("Completed With %d Errors.\n", errors); 

IOWR_ALTERA_AVALON_PIO_EDGE_CAP (BUTTONS_BASE, 0x0);
IOWR_ALTERA_AVALON_PIO_IRQ_MASK (BUTTONS_BASE, 0xF);
alt_irq_register (BUTTONS_IRQ, (void*) &buttons_status, buttons_isr);

while (1) {
    
 switch (buttons_status) {
    
    case 0x1: button_pressed = 1; break;
    case 0x2: button_pressed = 2; break;
    case 0x4: button_pressed = 3; break;
    case 0x8: button_pressed = 4; break;
     default: button_pressed = 0; break;
    
 }
    
    if (button_pressed != 0)
    printf("Button %d was pressed.\n", button_pressed);
    
    buttons_status = 0;
    
    switches = IORD_ALTERA_AVALON_PIO_DATA (SWITCHES_BASE);
    IOWR_ALTERA_AVALON_PIO_DATA (LEDS_BASE, switches);
    
    usleep (50000);
        
}

return (0);

}

































